﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using Docs.Excel;

namespace FeatureSamplesCS
{
    class Program
    {
        static void Main(string[] args)
        {
            ExcelWorkbook WBook = new ExcelWorkbook();
            WBook.Worksheets.Add("Values");

            WBook.Worksheets[0].Columns[0].Width = 200;
            WBook.Worksheets[0].Columns[1].Width = 15;
            WBook.Worksheets[0].Columns[2].Width = 435;
            for (short i = 3; i < 40; i += 2)
                WBook.Worksheets[0].Rows[i].Height = 10;

            WBook.Worksheets[0].Cells[0, 0].Value = "Demo of cell value of formats:";
            WBook.Worksheets[0].Cells[2, 0].Value = "Value";
            WBook.Worksheets[0].Cells[2, 2].Value = "Result";

            WBook.Worksheets[0].Cells[4, 0].Value = "Integer value, general format.";
            WBook.Worksheets[0].Cells[4, 2].Value = 345;
            WBook.Worksheets[0].Cells[4, 2].Style.StringFormat = "";

            WBook.Worksheets[0].Cells[6, 0].Value = "Integer value, financial format.";
            WBook.Worksheets[0].Cells[6, 2].Value = 345;
            WBook.Worksheets[0].Cells[6, 2].Style.StringFormat = "# ##0.00 $";

            WBook.Worksheets[0].Cells[8, 0].Value = "Integer value, numerical format.";
            WBook.Worksheets[0].Cells[8, 2].Value = 345;
            WBook.Worksheets[0].Cells[8, 2].Style.StringFormat = "0.00";

            WBook.Worksheets[0].Cells[10, 0].Value = "Integer value, percentage format.";
            WBook.Worksheets[0].Cells[10, 2].Value = 345;
            WBook.Worksheets[0].Cells[10, 2].Style.StringFormat = "0.00%";

            WBook.Worksheets[0].Cells[12, 0].Value = "Integer value, exponential format.";
            WBook.Worksheets[0].Cells[12, 2].Value = 345;
            WBook.Worksheets[0].Cells[12, 2].Style.StringFormat = "0.00E+00";

            WBook.Worksheets[0].Cells[14, 0].Value = "Double value, general format.";
            WBook.Worksheets[0].Cells[14, 2].Value = 12345.6789;

            WBook.Worksheets[0].Cells[16, 0].Value = "Double value, fractional format.";
            WBook.Worksheets[0].Cells[16, 2].Value = 12345.6789;
            WBook.Worksheets[0].Cells[16, 2].Style.StringFormat = "#\" \"?/2";

            WBook.Worksheets[0].Cells[18, 0].Value = "Double value, date format.";
            WBook.Worksheets[0].Cells[18, 2].Value = 12345.6789;
            WBook.Worksheets[0].Cells[18, 2].Style.StringFormat = "MM-DD-YYYY";

            WBook.Worksheets[0].Cells[20, 0].Value = "Double value, time format.";
            WBook.Worksheets[0].Cells[20, 2].Value = 98765.4321;
            WBook.Worksheets[0].Cells[20, 2].Style.StringFormat = "hh:mm";

            WBook.Worksheets[0].Rows[22].Height = 430;
            WBook.Worksheets[0].Cells[22, 0].Value = "Big text.";
            WBook.Worksheets[0].Cells[22, 0].Style.VerticalAlignment = TypeOfVAlignment.Center;
            WBook.Worksheets[0].Cells[22, 2].Style.WrapText = true;
            WBook.Worksheets[0].Cells[22, 2].Value =
                "Microsoft Corporation is an American public multinational corporation headquartered in Redmond, Washington, USA that develops, manufactures, licenses, and supports a wide range of products and services predominantly related to computing through its various product divisions. "
                + "Established on April 4, 1975 to develop and sell BASIC interpreters for the Altair 8800, Microsoft rose to dominate the home computer operating system (OS) market with MS-DOS in the mid-1980s, followed by the Microsoft Windows line of OSs. "
                + "Microsoft would also come to dominate the office suite market with Microsoft Office. The company has diversified in recent years into the video game industry with the Xbox and its successor, the Xbox 360 as well as into the consumer electronics market with Zune and the Windows Phone OS. "
                + "The ensuing rise of stock in the company's 1986 initial public offering (IPO) made an estimated four billionaires and 12,000 millionaires from Microsoft employees.\n"
                + "Primarily in the 1990s, critics contend Microsoft used monopolistic business practices and anti-competitive strategies including refusal to deal and tying, put unreasonable restrictions in the use of its software, and used misrepresentative marketing tactics; "
                + "both the U.S. Department of Justice and European Commission found the company in violation of antitrust laws. Known for its interviewing process with obscure questions, various studies and ratings were generally favorable to Microsoft's diversity within the company as well as its overall environmental"
                + "impact with the exception of the electronics portion of the business. \nFrom Wikipedia, the free encyclopedia";

            WBook.Worksheets[0].Cells[24, 0].Value = "Formula";
            WBook.Worksheets[0].Cells[24, 2].Value = "Result";
            WBook.Worksheets[0].Cells[26, 0].Value = "7+3=";
            WBook.Worksheets[0].Cells[26, 2].Value = "=7+3";
            WBook.Worksheets[0].Cells[28, 0].Value = "(2*2^2)%=";
            WBook.Worksheets[0].Cells[28, 2].Value = "=(2*2^2)%";
            WBook.Worksheets[0].Cells[30, 0].Value = "SIN(5)=";
            WBook.Worksheets[0].Cells[30, 2].Value = "=SIN(5)";
            WBook.Worksheets[0].Cells[32, 0].Value = "SUM(SIN(3);TAN(4);LOG(5;5))=";
            WBook.Worksheets[0].Cells[32, 2].Value = "=SUM(SIN(3);TAN(3);LOG(5;5))";
            WBook.Worksheets[0].Cells[34, 0].Value = "CEILING(12.35;0.1)=";
            WBook.Worksheets[0].Cells[34, 2].Value = "=CEILING(12.35;0.1)";
            WBook.Worksheets[0].Cells[36, 0].Value = "PI()=";
            WBook.Worksheets[0].Cells[36, 2].Value = "=PI()";
            WBook.Worksheets[0].Cells[38, 0].Value = "TODAY()=";
            WBook.Worksheets[0].Cells[38, 2].Value = "=TODAY()";
            WBook.Worksheets[0].Cells[38, 2].Style.StringFormat = "MMM-DD-YYYY";
            WBook.Worksheets[0].Cells[40, 0].Value = "TRUE()=";
            WBook.Worksheets[0].Cells[40, 2].Value = "=TRUE()";


            //Font and Alignment worksheet
            WBook.Worksheets.Add("Font");

            WBook.Worksheets[1].Columns[0].Width = 200;
            WBook.Worksheets[1].Columns[1].Width = 15;
            WBook.Worksheets[1].Columns[2].Width = 430;
            WBook.Worksheets[1].Columns[3].Width = 15;
            WBook.Worksheets[1].Columns[4].Width = 235;
            for (short i = 3; i < 38; i += 2)
                WBook.Worksheets[1].Rows[i].Height = 10;

            WBook.Worksheets[1].Cells[0, 0].Value = "Demo of cell font and alignment:";
            WBook.Worksheets[1].Cells[2, 0].Value = "Property in Docs.Excel:";
            WBook.Worksheets[1].Cells[2, 2].Value = "Value";
            WBook.Worksheets[1].Cells[2, 4].Value = "Result";

            WBook.Worksheets[1].Cells[4, 0].Value = ".Style.Font = ";
            WBook.Worksheets[1].Cells[4, 2].Value = "new CellFont(\"Times New Roman\", 10, Colors.KnownColor_WindowText)";
            WBook.Worksheets[1].Cells[4, 4].Value = "Feature Docs.Excel.";
            WBook.Worksheets[1].Cells[4, 4].Style.Font = new ExcelCellFont("Times New Roman", 10, ColorPalette.KnownColor_WindowText);

            WBook.Worksheets[1].Rows[6].Height = 22;
            WBook.Worksheets[1].Cells[6, 0].Value = ".Style.Font.Size =";
            WBook.Worksheets[1].Cells[6, 2].Value = "14";
            WBook.Worksheets[1].Cells[6, 2].Style.StringFormat = "@";
            WBook.Worksheets[1].Cells[6, 4].Value = "Feature Docs.Excel.";
            WBook.Worksheets[1].Cells[6, 4].Style.Font.Size = 14;

            WBook.Worksheets[1].Cells[8, 0].Value = ".Style.Font.Italic =";
            WBook.Worksheets[1].Cells[8, 2].Value = "true";
            WBook.Worksheets[1].Cells[8, 4].Value = "Feature Docs.Excel.";
            WBook.Worksheets[1].Cells[8, 4].Style.Font.Italic = true;

            WBook.Worksheets[1].Cells[10, 0].Value = ".Style.Font.Bold =";
            WBook.Worksheets[1].Cells[10, 2].Value = "true";
            WBook.Worksheets[1].Cells[10, 4].Value = "Feature Docs.Excel";
            WBook.Worksheets[1].Cells[10, 4].Style.Font.Bold = true;

            WBook.Worksheets[1].Cells[12, 0].Value = ".Style.Font.Strikeout =";
            WBook.Worksheets[1].Cells[12, 2].Value = "true";
            WBook.Worksheets[1].Cells[12, 4].Value = "Feature Docs.Excel";
            WBook.Worksheets[1].Cells[12, 4].Style.Font.Strikeout = true;

            WBook.Worksheets[1].Rows[14].Height = 21;
            WBook.Worksheets[1].Cells[14, 0].Value = ".Style.Font.Subscript =";
            WBook.Worksheets[1].Cells[14, 2].Value = "true";
            WBook.Worksheets[1].Cells[14, 4].Value = "Feature Docs.Excel";
            WBook.Worksheets[1].Cells[14, 4].Style.Font.Subscript = true;

            WBook.Worksheets[1].Rows[16].Height = 19;
            WBook.Worksheets[1].Cells[16, 0].Value = ".Style.Font.Superscript =";
            WBook.Worksheets[1].Cells[16, 2].Value = "true";
            WBook.Worksheets[1].Cells[16, 4].Value = "Feature Docs.Excel";
            WBook.Worksheets[1].Cells[16, 4].Style.Font.Superscript = true;

            WBook.Worksheets[1].Cells[18, 0].Value = ".Style.Font.Underline =";
            WBook.Worksheets[1].Cells[18, 2].Value = "TypeOfUnderline.Double";
            WBook.Worksheets[1].Cells[18, 4].Value = "Feature Docs.Excel";
            WBook.Worksheets[1].Cells[18, 4].Style.Font.Underline = TypeOfUnderline.Double;

            WBook.Worksheets[1].Rows[20].Height = 20;
            WBook.Worksheets[1].Cells[20, 0].Value = ".Style.Font.Underline =";
            WBook.Worksheets[1].Cells[20, 2].Value = "TypeOfUnderline.SingleAccounting";
            WBook.Worksheets[1].Cells[20, 4].Value = "Feature Docs.Excel";
            WBook.Worksheets[1].Cells[20, 4].Style.Font.Underline = TypeOfUnderline.SingleAccounting;

            WBook.Worksheets[1].Cells[22, 0].Value = ".Style.Font.Color =";
            WBook.Worksheets[1].Cells[22, 2].Value = "Colors.LightBlue";
            WBook.Worksheets[1].Cells[22, 4].Value = "Feature Docs.Excel";
            WBook.Worksheets[1].Cells[22, 4].Style.Font.Color = Color.LightBlue;

            WBook.Worksheets[1].Cells[24, 0].Value = ".Style.HorizontalAlignment =";
            WBook.Worksheets[1].Cells[24, 2].Value = "TypeOfHAlignment.Left";
            WBook.Worksheets[1].Cells[24, 4].Value = "Feature Docs.Excel";
            WBook.Worksheets[1].Cells[24, 4].Style.HorizontalAlignment = TypeOfHAlignment.Left;

            WBook.Worksheets[1].Cells[26, 0].Value = ".Style.HorizontalAlignment =";
            WBook.Worksheets[1].Cells[26, 2].Value = "TypeOfHAlignment.Center";
            WBook.Worksheets[1].Cells[26, 4].Value = "Feature Docs.Excel";
            WBook.Worksheets[1].Cells[26, 4].Style.HorizontalAlignment = TypeOfHAlignment.Center;

            WBook.Worksheets[1].Cells[28, 0].Value = ".Style.HorizontalAlignment =";
            WBook.Worksheets[1].Cells[28, 2].Value = "TypeOfHAlignment.Right";
            WBook.Worksheets[1].Cells[28, 4].Value = "Feature Docs.Excel";
            WBook.Worksheets[1].Cells[28, 4].Style.HorizontalAlignment = TypeOfHAlignment.Right;

            WBook.Worksheets[1].Rows[30].Height = 35;
            WBook.Worksheets[1].Cells[30, 0].Value = ".Style.VerticalAlignment =";
            WBook.Worksheets[1].Cells[30, 2].Value = "TypeOfVAlignment.Top";
            WBook.Worksheets[1].Cells[30, 4].Value = "Feature Docs.Excel";
            WBook.Worksheets[1].Cells[30, 4].Style.VerticalAlignment = TypeOfVAlignment.Top;

            WBook.Worksheets[1].Rows[32].Height = 35;
            WBook.Worksheets[1].Cells[32, 0].Value = ".Style.TypeOfVAlignment =";
            WBook.Worksheets[1].Cells[32, 2].Value = "TypeOfHAlignment.Center";
            WBook.Worksheets[1].Cells[32, 4].Value = "Feature Docs.Excel";
            WBook.Worksheets[1].Cells[32, 4].Style.VerticalAlignment = TypeOfVAlignment.Center;

            WBook.Worksheets[1].Rows[34].Height = 35;
            WBook.Worksheets[1].Cells[34, 0].Value = ".Style.TypeOfVAlignment =";
            WBook.Worksheets[1].Cells[34, 2].Value = "TypeOfHAlignment.Bottom";
            WBook.Worksheets[1].Cells[34, 4].Value = "Feature Docs.Excel";
            WBook.Worksheets[1].Cells[34, 4].Style.VerticalAlignment = TypeOfVAlignment.Bottom;

            WBook.Worksheets[1].Rows[36].Height = 125;
            WBook.Worksheets[1].Cells[36, 0].Value = ".Style.Rotation =";
            WBook.Worksheets[1].Cells[36, 0].Style.VerticalAlignment = TypeOfVAlignment.Center;
            WBook.Worksheets[1].Cells[36, 2].Value = "45";
            WBook.Worksheets[1].Cells[36, 2].Style.StringFormat = "@";
            WBook.Worksheets[1].Cells[36, 2].Style.VerticalAlignment = TypeOfVAlignment.Center;
            WBook.Worksheets[1].Cells[36, 4].Value = "Feature Docs.Excel";
            WBook.Worksheets[1].Cells[36, 4].Style.Rotation = 45;

            WBook.Worksheets[1].Rows[38].Height = 410;
            WBook.Worksheets[1].Cells[38, 0].Value = ".Style.Rotation =";
            WBook.Worksheets[1].Cells[38, 0].Style.VerticalAlignment = TypeOfVAlignment.Center;
            WBook.Worksheets[1].Cells[38, 2].Value = "255";
            WBook.Worksheets[1].Cells[38, 2].Style.StringFormat = "@";
            WBook.Worksheets[1].Cells[38, 2].Style.VerticalAlignment = TypeOfVAlignment.Center;
            WBook.Worksheets[1].Cells[38, 4].Value = "Feature Docs.Excel";
            WBook.Worksheets[1].Cells[38, 4].Style.Rotation = 255;


            //Colors worksheet
            WBook.Worksheets.Add("Colors");
            WBook.Worksheets[2].Cells[0, 0].Value = "Demo of cell background and style of borders:";
            WBook.Worksheets[2].Cells[2, 0].Value = "Property in Docs.Excel:";
            WBook.Worksheets[2].Cells[2, 2].Value = "Value";
            WBook.Worksheets[2].Cells[2, 4].Value = "Result";

            WBook.Worksheets[2].Columns[0].Width = 270;
            WBook.Worksheets[2].Columns[1].Width = 15;
            WBook.Worksheets[2].Columns[2].Width = 230;
            WBook.Worksheets[2].Columns[3].Width = 15;
            WBook.Worksheets[2].Columns[4].Width = 100;
            for (short i = 3; i < 8; i++)
            {
                WBook.Worksheets[2].Rows[i].Height = 10;
                WBook.Worksheets[2].Rows[++i].Height = 100;
            }

            WBook.Worksheets[2].Cells[4, 0].Value = ".Style.BackgroundColor =";
            WBook.Worksheets[2].Cells[4, 0].Style.VerticalAlignment = TypeOfVAlignment.Center;
            WBook.Worksheets[2].Cells[4, 2].Value = "Colors.SkyBlue";
            WBook.Worksheets[2].Cells[4, 2].Style.VerticalAlignment = TypeOfVAlignment.Center;
            WBook.Worksheets[2].Cells[4, 4].Style.BackgroundColor = Color.SkyBlue;

            WBook.Worksheets[2].Cells[6, 0].Value = ".Style.BackgroundColor =   " + ".Style.PatternForeColor =    " + ".Style.PatternFillStyle =";
            WBook.Worksheets[2].Cells[6, 0].Style.WrapText = true;
            WBook.Worksheets[2].Cells[6, 0].Style.VerticalAlignment = TypeOfVAlignment.Center;
            WBook.Worksheets[2].Cells[6, 2].Value = "Colors.Blue             " + "Colors.BrightGreen        " + "TypeOfFillPattern.ThinHorizontalStripe";
            WBook.Worksheets[2].Cells[6, 2].Style.WrapText = true;
            WBook.Worksheets[2].Cells[6, 2].Style.VerticalAlignment = TypeOfVAlignment.Center;
            WBook.Worksheets[2].Cells[6, 4].Style.BackgroundColor = Color.Blue;
            WBook.Worksheets[2].Cells[6, 4].Style.PatternForeColor = ColorPalette.BrightGreen;
            WBook.Worksheets[2].Cells[6, 4].Style.PatternFillStyle = TypeOfFillPattern.ThinHorizontalStripe;

            WBook.Worksheets[2].Rows[8].Height = 190;
            WBook.Worksheets[2].Cells[8, 0].Value = ".Style.BordersStyle.BottomLineColor =  " + ".Style.BordersStyle.BottomLineStyle =   "
                        + ".Style.BordersStyle.TopLineColor =   " + ".Style.BordersStyle.TopLineStyle =   " + ".Style.BordersStyle.LeftLineColor =   "
                        + ".Style.BordersStyle.LeftLineStyle =   " + ".Style.BordersStyle.RightLineColor =   " + ".Style.BordersStyle.RightLineStyle =   "
                        + ".Style.BordersStyle.Diagonal =   " + ".Style.BordersStyle.DiagonalLineColor =   " + ".Style.BordersStyle.DiagonalLineStyle =   ";
            WBook.Worksheets[2].Cells[8, 0].Style.WrapText = true;
            WBook.Worksheets[2].Cells[8, 2].Value = "Colors.Gold     " + "TypeOfBorderLine.Double   "
                        + "Colors.Indigo     " + "TypeOfBorderLine.Medium   " + "Colors.Green     "
                        + "TypeOfBorderLine.SlantDashDot   " + "Colors.Plum     " + "TypeOfBorderLine.MediumDashDot    "
                        + "TypeOfDiagonal.Both   " + "Colors.LightBlue    " + "TypeOfBorderLine.Dashed";
            WBook.Worksheets[2].Cells[8, 2].Style.WrapText = true;
            WBook.Worksheets[2].Cells[8, 4].Style.Borders.BottomLineColor = Color.Gold;
            WBook.Worksheets[2].Cells[8, 4].Style.Borders.BottomLineStyle = TypeOfBorderLine.Double;
            WBook.Worksheets[2].Cells[8, 4].Style.Borders.TopLineColor = Color.Indigo;
            WBook.Worksheets[2].Cells[8, 4].Style.Borders.TopLineStyle = TypeOfBorderLine.Medium;
            WBook.Worksheets[2].Cells[8, 4].Style.Borders.LeftLineColor = Color.Green;
            WBook.Worksheets[2].Cells[8, 4].Style.Borders.LeftLineStyle = TypeOfBorderLine.SlantDashDot;
            WBook.Worksheets[2].Cells[8, 4].Style.Borders.RightLineColor = Color.Plum;
            WBook.Worksheets[2].Cells[8, 4].Style.Borders.RightLineStyle = TypeOfBorderLine.MediumDashDot;
            WBook.Worksheets[2].Cells[8, 4].Style.Borders.Diagonal = TypeOfDiagonal.Both;
            WBook.Worksheets[2].Cells[8, 4].Style.Borders.DiagonalLineColor = Color.LightBlue;
            WBook.Worksheets[2].Cells[8, 4].Style.Borders.DiagonalLineStyle = TypeOfBorderLine.Dashed;

            WBook.Worksheets[2].Rows[9].Height = 10;
            WBook.Worksheets[2].Cells[10, 0].Value = ".Cells[\"E11:G11\"].IsMerged =";
            WBook.Worksheets[2].Cells[10, 2].Value = "true";
            WBook.Worksheets[2].Cells["E11:G11"].IsMerged = true;
            WBook.Worksheets[2].Cells["E11"].SetBordersStyles(TypeOfMultipleBorders.Outside, TypeOfBorderLine.Thin, Color.Black);

            WBook.Worksheets[2].Rows[11].Height = 10;
            WBook.Worksheets[2].Cells[12, 0].Value = ".Cells[\"E13:E14\"].IsMerged =";
            WBook.Worksheets[2].Cells[12, 2].Value = "true";
            WBook.Worksheets[2].Cells["E13:E14"].IsMerged = true;
            WBook.Worksheets[2].Cells["E13"].SetBordersStyles(TypeOfMultipleBorders.Outside, TypeOfBorderLine.Thin, Color.Black);

            WBook.Worksheets[2].Rows[14].Height = 10;
            WBook.Worksheets[2].Cells[15, 0].Value = ".Cells[\"E16:G19\"].IsMerged =";
            WBook.Worksheets[2].Cells[15, 2].Value = "true";
            WBook.Worksheets[2].Cells["E16:G19"].IsMerged = true;
            WBook.Worksheets[2].Cells["E16"].SetBordersStyles(TypeOfMultipleBorders.Outside, TypeOfBorderLine.Thin, Color.Black);

            // XLS
            string FileName = @"..\..\..\Values.xls";
            WBook.WriteXLS(FileName);

            // XLSX
            FileName = @"..\..\..\Values.xlsx";
            WBook.WriteXLSX(FileName);

            // Display Excel File
            System.Diagnostics.Process.Start(@"..\..\..\Values.xls");

        }
    }
}
