﻿using System;
using Docs.Excel;

namespace DefinedNameCell
{
    class Program
    {
        static void Main(string[] args)
        {
            // Create a new workbook.
            ExcelWorkbook wbook = new ExcelWorkbook();
            // Add new worksheet to workbook.
            wbook.Worksheets.Add("Sheet1");

            // Set name of cell.
            wbook.Worksheets[0].Cells[0, 0].DefinedName = "DefinedName1";
            wbook.Worksheets[0].Cells[0, 1].DefinedName = "DefinedName2";
            wbook.Worksheets[0].Cells[0, 2].DefinedName = "DefinedName3";
            wbook.Worksheets[0].Cells[1, 0].DefinedName = "DefinedName4";
            wbook.Worksheets[0].Cells[1, 1].DefinedName = "DefinedName5";
            wbook.Worksheets[0].Cells[1, 2].DefinedName = "DefinedName6";
            // Set values of cells.
            wbook.Worksheets[0].Cells[0, 0].Value = 1;
            wbook.Worksheets[0].Cells[0, 1].Value = 2;
            wbook.Worksheets[0].Cells[0, 2].Value = 3;
            wbook.Worksheets[0].Cells[1, 0].Value = 4;
            wbook.Worksheets[0].Cells[1, 1].Value = 5;
            wbook.Worksheets[0].Cells[1, 2].Value = 6;
            // Write a formula to cell.
            wbook.Worksheets[0].Cells[2, 0].Value = "=SUM(DefinedName1:DefinedName6)";

            string[] names = wbook.GetListNamesOfCells();
            for (int i = 0; i < names.Length; i++)
            {
                ExcelCell exce = wbook.GetCellByName(names[i]);
                if (exce != null)
                    exce.Value = (i + 1)*2;
            }

            //Write .xlsx file.
            wbook.WriteXLSX(@"..\..\..\NamesList.xlsx");

            //Write .xls file.
            wbook.WriteXLS(@"..\..\..\NamesList.xls");

            //Open specified file in MS Excel.
            System.Diagnostics.Process.Start(@"..\..\..\NamesList.xls");
        }
    }
}
